function chart_purchase_expense (widget) {
    "use strict";

    var model = openerp;

    widget.ChartPurchaseExpenseWidget = widget.Base.extend({
        template: 'ChartPurchaseExpense',
        data: [],
        resPartner: [],
        modelId: [],

        events: {
           
        },
        init: function (parent) {
            this._super(parent, {
                width: 6,
                height: 4
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        fetchInitial:function() {
            var self = this;
            self.$el.block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            self.$el.find('.widget-content.widget-loading').css('display','flex');

            self.fecthAccountInvoice().then(function (AccountInvoice) {
                return AccountInvoice;
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.fetchGetModelId();
            }).then(function(modelId) {
                self.modelId = modelId;
                return self.BuildChart();
            });
        },

        // getModelId
        fetchGetModelId: function() {
            var self = this;
            var defer = $.Deferred();
            var irModelData = new model.web.Model('ir.model.data');
            var getObtjectReference = irModelData.get_func('get_object_reference');

            this.alive(getObtjectReference('base', 'view_partner_form')).then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },

        // Obtener facturas
        fecthAccountInvoice: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','date_invoice','amount_total','origin'];
            var domain = [['state','in',['paid','open']],['type','=','in_invoice']];
            var AccountInvoice = new model.web.Model('account.invoice');
            AccountInvoice.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });

            return defer;
        },

        // Obtener facturas por cada proveedores
        getAccountInvoicePurchase:function(mes) {
            var self = this;
            if (mes < 10){
                var fecha = moment().format('YYYY')+'-'+'0'+mes;    
            }else{
                var fecha = moment().format('YYYY')+'-'+mes;    
            }
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return moment(inv.date_invoice).format('YYYY-MM') === fecha & inv.origin !== false;
            }));
        },

        // Obtener facturas de clientes
        getAccountInvoiceExpense:function(mes) {
            var self = this;
            if (mes < 10){
                var fecha = moment().format('YYYY')+'-'+'0'+mes;    
            }else{
                var fecha = moment().format('YYYY')+'-'+mes;    
            }
            return _.flatten(_.filter(self.AccountInvoice,function (inv) {
                return moment(inv.date_invoice).format('YYYY-MM') === fecha & inv.origin === false;
            }));
        },
        
        // Generar el Ranking
        BuildChart: function() {
            var self = this;
            console.log(self);
            var invoices;
            var mes = 0;
            var dataPurchase = [];
            var dataExpense = [];

            for (var i = 1; i <= 12; i++) {
                invoices = self.getAccountInvoicePurchase(i);
                var total = _.reduce(_.map(invoices,function(item) {
                    return item.amount_total;
                }),function(memo, num) {
                    return memo + num;
                },0);
                dataPurchase.push({
                    amount_total: accounting.formatNumber(total,0,".",","),
                })
            }
            
            for (var i = 1; i <= 12; i++) {
                invoices = self.getAccountInvoiceExpense(i);
                var total = _.reduce(_.map(invoices,function(item) {
                    return item.amount_total;
                }),function(memo, num) {
                    return memo + num;
                },0);
                dataExpense.push({
                    amount_total: accounting.formatNumber(total,0,".",","),
                })
            }

            // self.data = data;
            self.$el.unblock();
            self.$el.find('.widget-content.widget-loading').css('display','none');
            self.fetchChart(dataPurchase, dataExpense);
        },

        // Generar Grafico
        fetchChart: function (dataPurchase,dataExpense) {
            var self = this;
            var label = ['Enero', 'Febrero', 'Marzo','Abril','Mayo','Junio','Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre'];
            var bodyPurchase = [];
            var bodyExpense = [];
            var item;
            var rank = 12;

            // InInvoice
            if (dataPurchase.length < rank && dataPurchase.length > 0){
                rank= ranking.length;
            }
            for (var i = 0; i < rank; i++) {
                if (dataPurchase[i]) {
                    item = dataPurchase[i];
                }
                if (dataPurchase.length === 0) {
                    item = {};
                    item.amount_total = 0;
                }
                bodyPurchase.push(item.amount_total);
            }


            // OutInvoice
            if (dataExpense.length < rank && dataExpense.length > 0){
                rank= ranking.length;
            }
            for (var i = 0; i < rank; i++) {
                if (dataExpense[i]) {
                    item = dataExpense[i];
                }
                if (dataExpense.length === 0) {
                    item = {};
                    item.amount_total = 0;
                }
                bodyExpense.push(item.amount_total);
            } 

            // Global method for setting Y axis number format.
            Chart.scaleService.updateScaleDefaults('linear', {
              ticks: {
                callback: function(tick) {
                    return tick.toLocaleString('de-DE');
                }
              }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };
            var chart = new Chart(this.$el.find(".widget-content").find('canvas'), {
                type: 'line',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: 'Compras  ',
                            data: bodyPurchase,
                            backgroundColor: '#e3f2fd',
                            borderColor: '#64b5f6',
                            borderWidth: 2,
                            fill: false,
                        },
                        {
                            label: 'Gastos  ',                            
                            data: bodyExpense,
                            backgroundColor: '#c8e6c9',
                            borderColor: '#66bb6a',
                            borderWidth: 2,
                            fill: false,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    title: {
                        display: true,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                }
            });
        },
    });
}
